import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

enum SubjectState {
  none,
  isLk,
  isGk,
}

class HighEduGraduationConstants {
  static const int maxLks = 2;
  static const int maxGks = 9;
}

class SubjectCollection {
  List<Subject> collection;

  SubjectCollection(this.collection);
}

class Subject {
  String displayName;
  IconData icon;
  bool lkApplicable;

  SubjectState _subjectState = SubjectState.none;

  bool isLk() => _subjectState == SubjectState.isLk;
  bool isGk() => _subjectState == SubjectState.isGk;
  bool canLk(List<Subject> other) => lkApplicable && !isGk() && other.where((s) => s.isLk()).length < HighEduGraduationConstants.maxLks;
  bool canGk(List<Subject> other) => !isLk() && other.where((s) => s.isGk()).length < HighEduGraduationConstants.maxGks;

  set unsafeSubjectSet(SubjectState newState) => _subjectState = newState;
  set unsafeLkToggle(bool isLk) {
    _subjectState = isLk ? SubjectState.isLk : SubjectState.none;
  }
  set unsafeGkToggle(bool isGk) {
    _subjectState = isGk ? SubjectState.isGk : SubjectState.none;
  }

  Subject({required this.displayName, required this.icon, required this.lkApplicable});
}