import 'package:flutter/material.dart';
import 'package:marianum_mobile/widget/providerBridge.dart';

import '../../../../../widget/centeredLeading.dart';
import '../abiturCalculatorView.dart';
import '../models/abiturCalculatorModel.dart';

class SelectLkStep extends Step {
  SelectLkStep() : super(
    title: const Text("Leistungskurse"),
    content: StatefulBuilder(builder: (context, setState) {
      var model = AbiturCalculatorModel.get(context);
      var lkSubjects = model.getSubjects.collection.where((e) => e.isLk()).toList();
      return Column(
        children: [
          AbiturCalculatorView.listSubjects(lkSubjects),
          TextButton(
            onPressed: () {
              ProviderBridge.toDialog(context, model, (context, value) {
                return AlertDialog(
                  title: const Text("Leistungskurse"),
                  content: SingleChildScrollView(
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: model.getSubjects.collection.map((e) {
                        return ListTile(
                          leading: CenteredLeading(Icon(e.icon)),
                          title: Text(e.displayName),
                          trailing: Checkbox(
                            value: e.isLk(),
                            onChanged: e.isLk() || e.canLk(model.getSubjects.collection) ? (value) {
                              model.updateSubjects((collection) {
                                e.unsafeLkToggle = value!;
                              });
                            } : null,
                          ),
                        );
                      }).toList(),
                    ),
                  ),
                  actions: [
                    TextButton(
                      onPressed: () {
                        Navigator.of(context).pop();
                      },
                      child: const Text("Fertig"),
                    )
                  ],
                );
              });
            },
            child: Text("Leistungskurse ${lkSubjects.isEmpty ? "auswählen" : "ändern"}"),
          ),
        ],
      );
    }),
  );
}
class SelectLkStepTest extends StatelessWidget {
  const SelectLkStepTest({super.key});

  @override
  Widget build(BuildContext context) {
    return const Placeholder();
  }
}
