import 'package:flutter/material.dart';
import 'package:provider/provider.dart';


class ProviderBridge {
  static void toDialog<T extends ChangeNotifier>(BuildContext context, T data, Widget Function(BuildContext context, T value) builder) {
    showDialog(
      context: context,
      builder: (context) {
        return ChangeNotifierProvider.value(
          value: data,
          builder: (context, child) {
            return Consumer<T>(builder: (context, value, child) => builder(context, value));
          },
        );
      },
    );
  }
}
